fn fixRLength node = 
(
		l= curveLength node
		if (l>100) then
		(
			n= ceil (l/100)
			subdivideSegment node 1 1 (n-1)
			updateShape node
			for i=1 to n do
			(
				spl= copy node
				spl.name= node.name
				setUserPropBuffer spl (getUserPropBuffer node)
				j=(numKnots spl 1)
				while (j>=1) do
				(
					if (j!=i and j!=i+1) then
						deleteKnot spl 1 j
					j-= 1
				)
				spl.wireColor= (color 128 50 50)
				updateShape spl
			)
			delete node
		
		)

)

fn getPointDir viewPoint worldPoint gridPoint currentNode=
(
				box= (box2  (viewPoint+[5,5,5]) (viewPoint-[5,5,5]) )
				arr= (boxPickNode box)
				wpt= worldPoint
				
				n=0
				minDist= 10000
				minPt= gridPoint+[0,0,0.2]
				minDir= [0,1,0]
				for node in arr do
				(
					if (currentNode!=node) and (SuperClassOf node == shape) then
					(
						convertToSplineShape node
						for i=1 to (numSplines node) do
						(
							nk= (numKnots node i)
							
							pt= getKnotPoint node i 1
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i 1)==#line) then
									minDir= pt - (getKnotPoint node i 2)
								else
									minDir= pt - (getOutVec node i 1)
								
							)

							pt= getKnotPoint node i nk
							wpt.z= pt.z
							dist= distance pt wpt
							if (dist<minDist) then
							(
								minPt= pt
								minDist= dist
								if ((getSegmentType node i (nk-1))==#line) then
									minDir= pt - (getKnotPoint node i (nk-1))
								else
									minDir= pt - (getInVec node i nk)
							)

						)
					)
				)
				minDir= (normalize minDir)
				#(minPt,minDir)
)

fn AddTrack minPt minDir type nodeName length direction radius totalangle minPt2 minDir2 =
(
	disableSceneRedraw()
				if (type==1) then
				(
					l= line name:nodeName pos:minPt
					addNewSpline l
					addKnot l 1 #smooth #line minPt
					addKnot l 1 #smooth #line (minPt+minDir*length)
					updateShape l
					track= l
				)
				else
				if (type==3) then
				(
					l= line name:nodeName pos:minPt
					len= (distance  minPt minPt2)/3
					addNewSpline l
					addKnot l 1 #bezier #curve minPt minPt (minPt+minDir*len)
					addKnot l 1 #bezier #curve minPt2 (minPt2+minDir2*len) minPt2
					updateShape l
					track= l
				)
				else
				(
					vec= normalize (cross z_axis minDir)
					if (direction==2) then 
						pt= minPt-vec*radius
					else
						pt= minPt+vec*radius
					dir= minDir
					dir.z=0
					dir= normalize dir
					if (dir.x!=0) then
						angle= atan (dir.y/dir.x)
					else
						if (dir.y>0) then
							angle= 90
						else
							angle= -90
					if (dir.x<0) then
						if (dir.y<0) then
							angle= angle-180
						else
							angle= 180+angle
					if (totalangle>0) then
						ang= totalangle*3
					else
						ang= (length*360*3)/(2*pi*radius)
					if (ang>270) then
						ang= 270
					if (direction==2) then 
					(
						ato= angle+90
						afrom= ato-ang
					)
					else
					(
						afrom= angle-90 
						ato= afrom+ang
					)
					
					if (afrom<0) then
					(
						afrom= afrom+360
					)
					if (ato<0) then
						ato= ato+360
					if (ato>360) then
						ato= ato-360
					a= arc name:nodeName pos:pt radius:radius from:afrom to:ato
					convertToSplineShape a
					if (direction==1) then 
					(
						deleteKnot a 1 (numKnots a 1)
						deleteKnot a 1 (numKnots a 1)
						updateShape a
					)
					else
					(
						deleteKnot a 1 1
						deleteKnot a 1 1
						reverse a 1
						updateShape a
						
					)
					track= a
					
				)
	enableSceneRedraw()
	
	return track
)

fn createPods splObj minPrecision PHeight PBase PWidthC PWidthB material texLen = 
(
	h1= PBase
	h2= PHeight
	w1= PWidthB
	w2= PWidthC
	tu1= 0
	tu2= 0.5*((w1-w2)/w1)
	tu3= 1-0.5*((w1-w2)/w1)
	tu4= 1

	lenArray= getSegLengths splObj 1
	len= lenArray[2]
	numSegs= ((len/minPrecision) as integer ) as float
	v1= tangentCurve3d splObj 1 0
	p1= interpCurve3d splObj 1 0
	if (numSegs<1) then
		numSegs= 1
--	obj= (mesh pos:p1 length:len width:2 lengthsegs:numSegs widthsegs:3)
	verts= #()
	tvertices= #()
	fcs= #()
	for i=0 to numSegs do
	(
		v1= tangentCurve3d splObj 1 (((i as float)/numSegs))
		p1= interpCurve3d splObj 1 (((i as float)/numSegs))
		v1side= (cross v1 z_axis)
		verts[(i)*4+1]= p1+(v1side*w1)+(point3 0 0 h1)
		verts[(i)*4+2]= p1+(v1side*w2)+(point3 0 0 h2)
		verts[(i)*4+3]= p1-(v1side*w2)+(point3 0 0 h2)
		verts[(i)*4+4]= p1-(v1side*w1)+(point3 0 0 h1)
		
		tv= (len/texLen)*((i as float)/numSegs)
		tvertices[(i)*4+1]= (point3 tu1 tv 0)
		tvertices[(i)*4+2]= (point3 tu2 tv 0)
		tvertices[(i)*4+3]= (point3 tu3 tv 0)
		tvertices[(i)*4+4]= (point3 tu4 tv 0)

	)
	for i=1 to numSegs do
	(
		fcs[(i-1)*6+1]= (point3 ((i-1)*4+1) ((i)*4+1) ((i-1)*4+2) )
		fcs[(i-1)*6+2]= (point3 ((i-1)*4+2) ((i)*4+1) ((i)*4+2) )
		fcs[(i-1)*6+3]= (point3 ((i-1)*4+2) ((i)*4+2) ((i-1)*4+3) )
		fcs[(i-1)*6+4]= (point3 ((i-1)*4+3) ((i)*4+2) ((i)*4+3) )
		fcs[(i-1)*6+5]= (point3 ((i-1)*4+3) ((i)*4+3) ((i-1)*4+4) )
		fcs[(i-1)*6+6]= (point3 ((i-1)*4+4) ((i)*4+3) ((i)*4+4) )
		
	)
	
	disableSceneRedraw()
	obj= (mesh vertices:verts faces:fcs tverts:tvertices material:material)
	for i=1 to obj.numFaces do
	(
		mod= i-((i-1)/6)*6
		if (mod<3 or mod>4) then
			setFaceSmoothGroup obj i 1
		else
			setFaceSmoothGroup obj i 2
	)
	obj.wireColor= (color 142 93 0)
	buildTVFaces obj
	for f = 1 to obj.numfaces do 
	setTVFace obj f (getface obj f) 

	update obj
	enableSceneRedraw()
	
)

fn shapeFilt o = superClassOf o == Shape 

rollout CreateNormalRoad "Create Road"
(
	editText eName "Name" text:"" 
	radioButtons rbType "Type" labels:#(#Line, #Arc, #Flex) align:#left
	radioButtons rbDirection "Direction" labels:#(#Left, #Right) enabled:false align:#left
	spinner spnRoll1 "Roll 1" range:[-45,45,0] align:#left
	spinner spnRoll2 "Roll 2" range:[-45,45,0] align:#left
	spinner spnLength "Length" range:[0,500,100] align:#left
	spinner spnRadius "Radius" range:[5,1000,50] enabled:false align:#left
	spinner spnAngle "Angle" range:[0,90,45] enabled:false align:#left

	editText eMaxdist "MaxDistance" text:"-1" 
	editText eMindist "MinDistance" text:"0" 
	editText eParam1 "TrackWidth" text:"5.0" 
	editText eParam2 "Friction" text:"0.85" 
	editText eParam3 "SoundDist" text:"-1" 
	editText eParam4 "Quality" text:"15" 
	editText eParam5 "DamageFlag" text:"0" 
	editText eParam6 "Environment" text:"flat" 
	editText eParam7 "Visibility" text:"vis" 
	editText eParam8 "Tex1" text:"AsphaltDark1_DashedWhite.bmp" 
	editText eParam9 "TexLength" text:"6.0" 
	editText eParam10 "Tex2" text:"AsphaltDark1_side1.tga" 
	editText eParam11 "TexHeight" text:"0.2" 
	editText eParam12 "TexWidth" text:"0.2" 
	editText eParam13 "TexSlope" text:"0.5" 
	editText eEvent1 "Event1" text:""
	editText eEvent2 "Event2" text:""
	spinner spnVelocity "Velocity" range:[-1,300,-1] scale:1 type:#float align:#left
	button btn1 "Create"
	
	label lab1 "___________________________________"
	label lab2 "/\"\"\"\"\\"
	spinner spnPods "Segm Len" range:[5,100,5] scale:1 type:#float fieldwidth:30 
	spinner spnPodsH "CroneHeight" range:[-2,2,0.0] scale:0.1 type:#float fieldwidth:35 across:2
	spinner spnPodsB "BaseHeight" range:[-20,20,-10] scale:1 type:#float fieldwidth:35 
	spinner spnPodsWC "Crone Width" range:[1,10,2] scale:0.1 type:#float fieldwidth:35 across:2
	spinner spnPodsWB "Base Width" range:[2,50,22] scale:0.1 type:#float fieldwidth:35 
	materialbutton mbTrackMat "Material" 
	spinner spnTexLen "Tex Len" range:[1,1000,4] scale:1 type:#float
	pickbutton btn0 "Create" filter:shapeFilt

	tool CreateTrack
	( 
		local nodeName
		local Pt1,Dir1
		local tr
                local r1= spnRadius.value
		on mousePoint clickno do 
			if clickno != 2 then
			(
				if (eName.text=="") then
					nodeName= "none"
				else
					if (getNodeByName eName.text)==undefined then
						nodeName= eName.text
					else
						nodeName= uniqueName eName.text
				ptArr= (getPointDir viewPoint worldPoint gridPoint #undefined)
                                if (rbType.state==2) then
				(
				 if (rbDirection.state==2) then
				 (
  				   r1= -r1
                                 )
                                )
				else
				(
  				 r1= 0
				)

				if (rbType.state==3) then
				(
					Pt1= ptArr[1]
					Dir1= ptArr[2]
					tr= (AddTrack Pt1 Dir1 rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value Pt1 Dir1 )
				)
				else
				(
					tr= (AddTrack ptArr[1] ptArr[2] rbType.state (nodeName) spnLength.value rbDirection.state spnRadius.value spnAngle.value [0,0,0] [0,0,0])
				)
				setUserProp tr "Type" "road"
				setUserProp tr "Length" (spnLength.value as string)
				setUserProp tr "Radius1" (r1 as string)
				setUserProp tr "Roll1" (spnRoll1.value as string)
				setUserProp tr "Roll2" (spnRoll2.value as string)
				setUserProp tr "MaxDist" eMaxdist.text
				setUserProp tr "MinDist" eMindist.text
				setUserProp tr "TrackWidth" eParam1.text
				setUserProp tr "Friction" eParam2.text
				setUserProp tr "SoundDist" eParam3.text
				setUserProp tr "Quality" eParam4.text
				setUserProp tr "DamageFlag" eParam5.text
				setUserProp tr "Environment" eParam6.text
				setUserProp tr "Visibility" eParam7.text
				setUserProp tr "Tex1" eParam8.text
				setUserProp tr "TexLength" eParam9.text
				setUserProp tr "Tex2" eParam10.text
				setUserProp tr "TexPar1" eParam11.text
				setUserProp tr "TexPar2" eParam12.text
				setUserProp tr "TexPar3" eParam13.text

				if (eEvent1.text!="") then
					setUserProp tr "Event1" eEvent1.text
				if (eEvent2.text!="") then
					setUserProp tr "Event2" eEvent2.text
				if (spnVelocity.value>=0) then
				(
					setUserProp tr "Velocity" (spnVelocity.value as string)
				)
				tr.wireColor= (color 128 50 50)
				fixRLength tr
			)
			else
				if (rbType.state==3) then
					#stop

		on mouseMove clickno do
		(
			if (rbType.state==3) then
			(
				ptArr= (getPointDir viewPoint worldPoint gridPoint tr)
				len= (distance Pt1 ptArr[1])/3
				setKnotPoint tr 1 2 ptArr[1]
				setInVec tr 1 2 (ptArr[1]+ptArr[2]*len)
				setOutVec tr 1 2 ptArr[1]
				setOutVec tr 1 1 (Pt1+Dir1*len)
				updateShape tr
			)
		)
	) 

	on rbType changed state do
	(
		case state of
		(
			1:
			(
				spnLength.enabled= true
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
			)
			2:
			(
				spnLength.enabled= true
				spnRadius.enabled= true
				spnAngle.enabled= true
				rbDirection.enabled= true
			)
			3:
			(
				spnLength.enabled= false
				spnRadius.enabled= false
				spnAngle.enabled= false
				rbDirection.enabled= false
			)
		)
	)

	on btn0 picked obj do
	(
		createPods obj spnPods.value spnPodsH.value spnPodsB.value spnPodsWC.value spnPodsWB.value mbTrackMat.material spnTexLen.value
	)
	on btn1 pressed do
	(
		startTool CreateTrack
	)
)

